Iwage
==
A HTML5 Image and Graphic Editor.


![Iwage Screenshot](iwage/raw/master/screenshot.png)


Iwage is web application to create and edit graphics and images. You can use it to edit your images or to create graphics right on your browser. Create graphics by adding text, forms, or images. Then you can edit your graphic as an image. Edit an image by cropping it or by adding differents filters or effects.
      
### Image Editing Features

**Main:**

* Open Image without upload
* Save in different sizes
* Undo & Redo
* Back To Original Image (Undo anything)
* Edit as a Graphic

**Adjustments:**

* Background Color (when transparent is present)
* Brightness and Contrast controls
* Hue and Saturation controls
* Rotate
* Invert (Horizontal & Vertical)
* Roundly corners

**Filters:**

* Color Halftone
* Denoise
* Dot Screen
* Edge Work
* Ink
* Lens Blur
* Noise
* Hexagonal Pixelate
* Sepia
* Triangle Blur
* Unsharp Mask
* Vibrance
* Vignette

**Effects:**

* Bulge/Pinch
* Reflection
* Swirl
* Tilt Shift
* Zoom Blur

### Graphic Editing Features:


**Main:**

* Open From JSON (Editable Graphic)
* Save To JSON
* Edit as a Image

**Graphics Manipulation:**

* Undo & Redo
* Copy & Paste
* Change canvas size

**Adding Graphics:**

* Text
* SVG
* Images
* Line
* Rectangle
* Triangle
* Circle

**Technologies & Libraries:**

* WebGL
* Canvas
* HTML5 File Api
* fabric.js
* glfx.js
* ExtJs

**Supported browsers:**

- Firefox 2+
- Safari 3+
- Opera 9.64+
- Chrome (all versions should work)
- IE9+

**TODO**

* Add a live demo.
* Remove jQuery (and jQuery UI).


**Author:** IEnter

**Copyright:** Copyright (c) 2011 IEnter S.A.

**License:** MIT License

**WebSite:** http://www.ienter.net

**Team:** Valentín Starck (Developer), Adrián E. Piñeyro (Product/Project Manager)
